#include "stdio.h"
#include "uart.h"
#include "delay.h"
#include "RPM_Encoder.h"
#include "stepper_motor.h"
#include "lcd.h"
#include "i2c.h"
char char_lcd[20];
uint8_t dir=0;
uint64_t previous_millis;
int main(void)
{
	SCB->CPACR |= ((3UL << 10*2)|(3UL << 11*2));
	i2c_init();
	stepper_init(9000);
	systick_init_ms(16000000);
	uart2_rxtx_init(115200,16000000);
	Encoder_init(1440);
	lcd_init();
	stepper_motor_setDirection(Stepper_Clockwise);
	stepper_motor_start();
	while(1)
	{
		if(new_rpm_available()==new_rpm)
		{
			setCursor(0,0);
			lcd_send_string("Current RPM");
			sprintf(char_lcd,"%0.2f        ",get_rpm());
			setCursor(0,1);
			lcd_send_string(char_lcd);
			setCursor(0,2);
			if(get_direction()==ClockWise)
			{
				lcd_send_string("Clockwise        ");
			}
			else
			{
				lcd_send_string("Counter clockwise");
			}
		}

		if(millis()-previous_millis>5000)
		{
			previous_millis=millis();
			dir=!dir;
			stepper_motor_setDirection(dir);

		}

	}
}
