#include "stepper_motor.h"
#include "stm32f4xx.h"

void stepper_init(uint32_t freq)
	{
	#define TIM2_AF 0x01
	RCC->AHB1ENR	|=	RCC_AHB1ENR_GPIOAEN;
	GPIOA->MODER	|=	GPIO_MODER_MODE0_1;
	GPIOA->MODER	&= ~GPIO_MODER_MODE0_0;
	GPIOA->MODER	|= GPIO_MODER_MODE1_0;
	GPIOA->AFR[0] |= (TIM2_AF<<0);

	RCC->APB1ENR  |=  RCC_APB1ENR_TIM2EN;
	TIM2->CR1     &=~ TIM_CR1_CEN;
	TIM2->CCMR1|=TIM_CCMR1_OC1M_0|TIM_CCMR1_OC1M_1;
	TIM2->CCER|=TIM_CCER_CC1E;
	TIM2->PSC=freq;
	TIM2->ARR=1;
	}

void stepper_motor_start()
	{
	TIM2->CR1     |= TIM_CR1_CEN;
	}

void stepper_motor_stop()
	{
	TIM2->CR1     &=~ TIM_CR1_CEN;
	}




static void stepper_motor_clockwise()
	{
	GPIOA->ODR|=GPIO_ODR_OD1;
	}


static void stepper_motor_counter_clockwise()
	{
	GPIOA->ODR&=~GPIO_ODR_OD1;
	}



void stepper_motor_setDirection(stepper_motor_Directions dir)
{
	if(dir==Stepper_Clockwise){stepper_motor_clockwise();}
	if(dir==Stepper_Counter_Clockwise){stepper_motor_counter_clockwise();}
}



void stepper_motor_chage_speed(uint32_t freq)
{
	TIM2->PSC=freq;
}
